export const obj = {
    position: function () {
        if (!this[0]) {
            return;
        }

        var offsetParent,
            offset,
            parentOffset = { top: 0, left: 0 },
            elem = this[0];

        // fixed elements are offset from window (parentOffset = {top:0, left: 0}, because it is it's only offset parent
        if (jQuery.css(elem, "position") === "fixed") {
            // we assume that getBoundingClientRect is available when computed position is fixed
            offset = elem.getBoundingClientRect();
        } else {
            // Get *real* offsetParent
            offsetParent = this.offsetParent();

            // Get correct offsets
            offset = this.offset();
            if (!jQuery.nodeName(offsetParent[0], "html")) {
                parentOffset = offsetParent.offset();
            }

            // Add offsetParent borders
            parentOffset.top += jQuery.css(
                offsetParent[0],
                "borderTopWidth",
                true
            );
            parentOffset.left += jQuery.css(
                offsetParent[0],
                "borderLeftWidth",
                true
            );
        }

        // Subtract parent offsets and element margins
        // note: when an element has margin: auto the offsetLeft and marginLeft
        // are the same in Safari causing offset.left to incorrectly be 0
        return {
            top:
                offset.top -
                parentOffset.top -
                jQuery.css(elem, "marginTop", true),
            left:
                offset.left -
                parentOffset.left -
                jQuery.css(elem, "marginLeft", true),
        };
    },
};
