function getElementKey(element, index) {
    function escape(key) {
        var escapeRegex = /[=:]/g;
        var escaperLookup = {
            "=": "=0",
            ":": "=2",
        };
        var escapedString = key.replace(escapeRegex, function (match) {
            return escaperLookup[match];
        });
        return "$" + escapedString;
    }

    // Do some typechecking here since we call this blindly. We want to ensure
    // that we don't block potential future ES APIs.
    if (
        typeof element === "object" &&
        element !== null &&
        element.key != null
    ) {
        // Explicit key
        return escape("" + element.key);
    } // Implicit key determined by the index in the set

    return index.toString(36);
}
