_.uniq = _.unique = function (array, isSorted, iterator, context) {
    if (_.isFunction(isSorted)) {
        context = iterator;
        iterator = isSorted;
        isSorted = false;
    }
    var initial = iterator ? _.map(array, iterator, context) : array;
    var results = [];
    var seen = [];
    each(initial, function (value, index) {
        if (
            isSorted
                ? !index || seen[seen.length - 1] !== value
                : !_.contains(seen, value)
        ) {
            seen.push(value);
            results.push(array[index]);
        }
    });
    return results;
};
